!	----------------------------------------------------------------------
!	file name: SaveResults.f90
!
!	Save all results
!	----------------------------------------------------------------------


subroutine SaveResults()


	use Globals

	implicit none


	!	save converged values and wages

	open(1, file='Output\W.txt', status='unknown')
	write(1, '(<nx+1>F12.6)') (agrid(ia), (W(ia,ix), ix=1,nx), ia=1,na)
	close(1)

	open(1, file='Output\U.txt', status='unknown')
	write(1, '(2F12.6)') (agrid(ia), U(ia), ia=1,na)
	close(1)

	open(1, file='Output\J.txt', status='unknown')
	write(1, '(<nx+1>F12.6)') (agrid(ia), (J(ia,ix), ix=1,nx), ia=1,na)
	close(1)

	open(1, file='Output\EmaxJG.txt', status='unknown')
	write(1, '(2F12.6)') (dagrid(ia), EmaxJG(ia), ia=1,dna)
	close(1)

	open(1, file='Output\EmaxJF.txt', status='unknown')
	write(1, '(<nx+1>F12.6)') (agrid(ia), (EmaxJF(ia,ix), ix=1,nx), ia=1,na)
	close(1)

	open(2, file='Output\AE.txt', status='unknown')
	write(2, '(<nx+1>F12.6)') (agrid(ia), (AE(ia,ix), ix=1,nx), ia=1,na)
	close(2)

	open(2, file='Output\AU.txt', status='unknown')
	write(2, '(2F12.6)') (agrid(ia), AU(ia), ia=1,na)
	close(2)

	open(2, file='Output\CE.txt', status='unknown')
	write(2, '(<nx+1>F12.6)') (agrid(ia), (CE(ia,ix), ix=1,nx), ia=1,na)
	close(2)

	open(2, file='Output\CU.txt', status='unknown')
	write(2, '(2F12.6)') (agrid(ia), CU(ia), ia=1,na)
	close(2)

	open(3, file='Output\Wage.txt', status='unknown')
	write(3, '(<nx+1>F12.6)') (agrid(ia), (Wage(ia,ix), ix=1,nx), ia=1,na)
	close(3)

	open(3, file='Output\dWage.txt', status='unknown')
	write(3, '(<nx+1>F12.6)') (dagrid(ia), (dWage(ia,ix), ix=1,nx), ia=1,dna)
	close(3)


	!	save measures

	open(4, file='Output\mu.txt', status='unknown')
	write(4, '(<nx+1>F12.6)') (dagrid(ia), (100.0D0*mu(ia,ix), ix=1,nx), ia=1,dna)
	close(4)

	open(4, file='Output\phi.txt', status='unknown')
	write(4, '(2F12.6)') (dagrid(ia), 100.0D0*phi(ia), ia=1,dna)
	close(4)

	open(4, file='Output\muhat.txt', status='unknown')
	write(4, '(<nx+1>F12.6)') (dagrid(ia), (100.0D0*muhat(ia,ix), ix=1,nx), ia=1,dna)
	close(4)

	open(4, file='Output\phihat.txt', status='unknown')
	write(4, '(2F12.6)') (dagrid(ia), 100.0D0*phihat(ia), ia=1,dna)
	close(4)

	open(4, file='Output\mutilde.txt', status='unknown')
	write(4, '(<nx+1>F12.6)') (dagrid(ia), (100.0D0*mutilde(ia,ix), ix=1,nx), ia=1,dna)
	close(4)

	open(4, file='Output\phitilde.txt', status='unknown')
	write(4, '(2F12.6)') (dagrid(ia), 100.0D0*phitilde(ia), ia=1,dna)
	close(4)


	!	save distributions

	open(1, file='Output\AsstEarnDensity.txt', status='unknown')
	open(2, file='Output\AsstDensity.txt', status='unknown')
	open(3, file='Output\EarnDensity.txt', status='unknown')
	open(4, file='Output\AsstEarnDist.txt', status='unknown')
	open(5, file='Output\AsstDist.txt', status='unknown')
	open(6, file='Output\EarnDist.txt', status='unknown')
	open(7, file='Output\Earnings.txt', status='unknown')

	write(1, '(<dnx+1>F12.6)') ((AsstEarnDensity(ia,ix),ix=0,dnx),ia=1,dna)
	write(2, '(F12.6)') AsstDensity
	write(3, '(F12.6)') EarnDensity
	write(4, '(<dnx+1>F12.6)') ((AsstEarnDist(ia,ix),ix=0,dnx),ia=1,dna)
	write(5, '(F12.6)') AsstDist
	write(6, '(F12.6)') EarnDist
	write(7, '(F12.6)') Earnings

	close(1)
	close(2)
	close(3)
	close(4)
	close(5)
	close(6)
	close(7)


end subroutine
