clear;
clc;


%   load data

model = 1;

switch model 
case 1  
cd ..\FortranFinal\Concave_Utility\AKY_FL\Output
case 2
cd ..\FortranFinal\Concave_Utility\AXKY_FL\Output\Benchmark
case 3
cd ..\FortranFinal\Concave_Utility\AXKY_FL\Output\HighVolatility
case 4
cd ..\FortranFinal\Concave_Utility\AXKY_FL\Output\Exog_Separation
end

load Kdata.txt
load Pdata.txt
load Edata.txt
load Udata.txt
load Vdata.txt
load hEUdata.txt
load hUEdata.txt
load THdata.txt
load Wdata.txt
load KEdata.txt
load KUdata.txt
load Cdata.txt
load CEdata.txt
load CUdata.txt


%   number of variables and observations
Nperiod = size(Udata, 1);
Nvar = 13;
Pdata = Pdata(end-Nperiod+1:end);

% put things together
tsdata = zeros(Nperiod,Nvar);
tsdata(:,1) = Edata;
tsdata(:,2) = Udata;
tsdata(:,3) = Vdata;
tsdata(:,4) = THdata;
tsdata(:,5) = hEUdata;
tsdata(:,6) = hUEdata;
tsdata(:,7) = Kdata;
tsdata(:,8) = Wdata;
tsdata(:,9) = Pdata;
tsdata(:,10) = Cdata;
tsdata(:,11) = KUdata./KEdata;
tsdata(:,12) = Pdata.*Edata;
tsdata(:,13) = KUdata;

e = tsdata(:,1);
u = tsdata(:,2);
v = tsdata(:,3);
th = tsdata(:,4);
hEU = tsdata(:,5);
hUE = tsdata(:,6);
k = tsdata(:,7);
w = tsdata(:,8);
p = tsdata(:,9);
q = hUE./th;
c= tsdata(:,10);
kr= tsdata(:,11);
y= tsdata(:,12);
ku= tsdata(:,13);

hEE = 1-hEU;
hUU = 1-hUE;


for j=1:Nperiod/3
 hEE_q(j)= hEE(3*(j-1)+1)*hEE(3*(j-1)+2)*hEE(3*(j-1)+3) + hEE(3*(j-1)+1)*hEU(3*(j-1)+2)*hUE(3*(j-1)+3) + hEU(3*(j-1)+1)*hUE(3*(j-1)+2)*hEE(3*(j-1)+3) + hEU(3*(j-1)+1)*hUU(3*(j-1)+2)*hUE(3*(j-1)+3);
 hUU_q(j)= hUU(3*(j-1)+1)*hUU(3*(j-1)+2)*hUU(3*(j-1)+3) + hUU(3*(j-1)+1)*hUE(3*(j-1)+2)*hEU(3*(j-1)+3) + hUE(3*(j-1)+1)*hEU(3*(j-1)+2)*hUU(3*(j-1)+3) + hUE(3*(j-1)+1)*hEE(3*(j-1)+2)*hEU(3*(j-1)+3);
end
hEE_q = hEE_q';
hUU_q = hUU_q';

hEU_q = 1- hEE_q;
hUE_q = 1- hUU_q;

disp('     hEE       hEU        hUU       hUE')
disp(' monthly and quarterly')
mean([hEE hEU hUU hUE])
mean([hEE_q hEU_q hUU_q hUE_q])

qdata=tsdata(1:3:end,:);
qdata(:,5) = hEU_q;
qdata(:,6) = hUE_q;

disp (' E   U    V   theta   hEU   hUE    K   W    P    C   Ku/Ke    Y   Ku')
disp(' monthly and quarterly')
mean(tsdata)
ave=mean(qdata)

%	take log
qdata = log(qdata);

%	HP filter
lambda=10^5;
for i = 1:Nvar
  qdata(:,i) = hpfilter(qdata(:,i), lambda);
end


%	statistics

stdev = zeros(Nvar,1);
corr = zeros(Nvar,Nvar);
lag = 1;
autocorr = zeros(Nvar,lag);

for i = 1:Nvar
   stdev(i) = std(qdata(:,i));
end

corr = corrcoef(qdata);

for i=1:Nvar
   for j=1:lag
      corrtmp = corrcoef(qdata(1:end-j,i), qdata(j+1:end,i));
      autocorr(i,j) = corrtmp(2,1);
   end
end

%   write statistics on file

outS = fopen('ModelM_Stats_quarterly.txt','W');

fprintf(outS, '%8s', 'E', 'U', 'V', 'Theta', 's', 'f', 'K', ' W ', ' P ', ' C ', ' K^u/K^e ', 'Y', 'K^u');
fprintf(outS, '\n\n\n');

fprintf(outS, 'Averages \n\n');
fprintf(outS, '%8.3f', ave');
fprintf(outS, '\n\n\n');

fprintf(outS, 'Standard deviations (percent) \n\n');
fprintf(outS, '%8.2f', 100*stdev');
fprintf(outS, '\n\n\n');

fprintf(outS, 'Relative Standard deviations\n\n');
fprintf(outS, '%8.2f', (stdev/stdev(9))');
fprintf(outS, '\n\n\n');

fprintf(outS, 'Auto-Correlation Coefficients \n\n');
fprintf(outS, '%8.2f', autocorr(:,1)');
fprintf(outS, '\n\n\n');

fprintf(outS, 'Correlation Coefficients \n\n');
for i=1:Nvar
	fprintf(outS, '%8.2f', corr(i,:));
    fprintf(outS, '\n');
end
fprintf(outS, '\n\n\n');

fclose(outS);


if model == 1
cd ..\..\..\..\MatlabFinal;
end
if model > 1 
cd ..\..\..\..\..\MatlabFinal;
end

